#ifndef gurus_h
#define gurus_h
#pragma interface
#ifndef MISC_H
    #include <misc.h>
#endif
#ifndef MODULE_H
    #include <module.h>
#endif

#include <modapi_def.h>
#include <modapi.h>

#define _TLMP_gurupath

enum GURUPATH_MODE {GURUPATH_EVAL, GURUPATH_EDIT};

#define MAXGURUPATH		3		// _F_gurupath::path3. Modify is more paths
								// are needed.

class GURUPATH_STATUS {
public:
	SSTRING title;		// Short title of the node
	bool wearehere;		// This is the node under edition now
	bool is_possible;	// This path is possible, prior condition are met
	bool is_filled;		// The user has supplied valid input
						// so this path is either completed or we
						// can pass to other path
	bool some_errors;	// There are some problems with the configuration
						// of this node
	int level;			// top level is 0, each step to the right is + 1
	int nbpath;			// Number of sub-option
	GURUPATH_STATUS *tb[MAXGURUPATH];
					// Status of the sub-options, maximum
	/*~PROTOBEG~ GURUPATH_STATUS */
public:
	GURUPATH_STATUS (void);
	~GURUPATH_STATUS (void);
	/*~PROTOEND~ GURUPATH_STATUS */
};

struct _F_gurupath{
	class gurupath_private *priv;
	void settitle (const char *title);
	void setintro (const char *longtext);
	void setterminal (const char *shortext, const char *longtext);
	bool edit (HELP_FILE &);
	bool edit ();
	#define _F_gurupath_dialog(nom) void nom dialog(DIALOG &dia)
	virtual _F_gurupath_dialog( )=0;
	#define _F_gurupath_eval(nom) int nom eval(GURUPATH_MODE mode, GURUPATH_STATUS &status)
	virtual _F_gurupath_eval( )=0;
	#define _F_gurupath_path1(nom) int nom path1(GURUPATH_MODE mode, GURUPATH_STATUS &status)
	virtual _F_gurupath_path1( );
	#define _F_gurupath_path2(nom) int nom path2(GURUPATH_MODE mode, GURUPATH_STATUS &status)
	virtual _F_gurupath_path2( );
	#define _F_gurupath_path3(nom) int nom path3(GURUPATH_MODE mode, GURUPATH_STATUS &status)
	virtual _F_gurupath_path3( );
};

#define _TLMP_gurumanage

struct _F_gurumanage{
	#define _F_gurumanage_exec(nom) int nom exec(GURUPATH_MODE mode, GURUPATH_STATUS &status)
	virtual _F_gurumanage_exec( )=0;
};

#include "gurus.p"

#endif
