/* ***********

	Check comments starting with // ### and fill appropriate code there

   ***********
*/
#pragma implementation
#include <stdio.h>
#include <string.h>
#include <translat.h>
#include "printconf.h"
#include "printconf.m"

MODULE_DEFINE_VERSION(printconf);

PUBLIC MODULE_printconf::MODULE_printconf()
	: LINUXCONF_MODULE("printconf")
{
	linuxconf_loadmsg ("printconf",PACKAGE_REV);
}


static const char *menu_config=NULL;
static const char *menu_control=NULL;

PUBLIC void MODULE_printconf::setmenu (
	DIALOG &dia,
	MENU_CONTEXT context)
{
	if (context == MENU_MISCSERV){
		menu_config = MSG_U(M_printconf,"Printer configuration");
		dia.new_menuitem ("printconf","",menu_config);
	}else if (context == MENU_CONTROL_PANEL){
		menu_control = MSG_U(M_printqueue,"Printers management");
		dia.new_menuitem ("printconf","",menu_control);
	}
}

PUBLIC int MODULE_printconf::domenu (
	MENU_CONTEXT context,
	const char *key)
{
	if (context == MENU_MISCSERV){
		if (key == menu_config){
			xconf_notice ("Sorry, not done yet!");
		}
	}else if (context == MENU_CONTROL_PANEL){
		if (key == menu_control){
			queue_manage();
		}
	}
	return 0;
}


PUBLIC int MODULE_printconf::dohtml (const char *key)
{
	int ret = LNCF_NOT_APPLICABLE;
	if (strcmp(key,"printconf")==0){
		// ### Insert any menu and dialog here
		ret = 0;
	}
	return ret;
}


static void usage()
{
	xconf_error (MSG_U(T_USAGE
		,"Module printconf\n"
		 "linuxconf --modulemain printconf [ specific options ]\n"
		 "\n")
		);
}

PUBLIC void MODULE_printconf::usage (SSTRINGS &tb)
{
	tb.add (new SSTRING (MSG_R(T_USAGE)));
}

PUBLIC int MODULE_printconf::execmain (int argc , char *argv[], bool)
{
	int ret = LNCF_NOT_APPLICABLE;
	const char *pt = strrchr(argv[0],'/');
	if (pt != NULL){
		pt++;
	}else{
		pt = argv[0];
	}
	if (strcmp(pt,"printconf")==0){
		ret = -1;
		if (argc == 1){
			// ### Place call to main menu of the module
		}else{
			// ### Add some option parsing for the module
			::usage();
		}
	}
	return ret;
}


static MODULE_printconf printconf;

