/* this is the queue manager */

#include <stdlib.h>
#include <string.h>
#include "printer.h"
#include "printer.m"

#include "deez_parser_handle.h"
#include "printer_common_data.h"
#include "printer_cfile.h"

void list_current_queue_state(char *which_one)
{
    DIALOG_TEXTBOX dia_queinfo;
    char my_buff[2048];
    char tempy[TYPICAL_STRING_SIZE];
    int  my_selection;
    SSTRINGS my_text;

    sprintf(tempy, "lpq -P%s", which_one);
    execute_proggy_and_get_stdout(tempy, my_buff, 2000);

    {
        char *where_to_zero;
        char *where_to_read_from;

        where_to_read_from=&my_buff[0];
        where_to_zero=strchr(where_to_read_from, '\n');
        while((*where_to_read_from)&&where_to_zero){
            *where_to_zero=0;
            my_text.add(new SSTRING(where_to_read_from));
            where_to_read_from=where_to_zero+1;
            where_to_zero=strchr(where_to_read_from, '\n');
        }
    }

    if(!strcmp(my_buff, "no entries\n"))
        strcpy(my_buff, MSG_U(M_QMGRNOJOBS, "There are no jobs for this queue.\n"));
    dia_queinfo.newf_text("", my_text);
    sprintf(tempy, MSG_U(M_QMGRJOBSLISTINGFOR, "Jobs listing for %s"), which_one);
    dia_queinfo.edit(tempy, MSG_U(M_QMGROUTPUTLPQ, "Output from the lpq command:"), help_nil, my_selection, MENUBUT_QUIT);
}

void edit_specified_queue(char *which_one, char *str_for_all)
{
    int    my_selection;

    my_selection=0;
    DIALOG dia_queopts;

    while(1)
    {
//    DIALOG dia_queopts;
    MENU_STATUS    my_button;
    char   my_titletx[TYPICAL_STRING_SIZE];
    char   my_header_text[1024];
    char   my_command_line[TYPICAL_STRING_SIZE];
    char   *my_queue_report;
    char   my_added_particle[TYPICAL_STRING_SIZE]; /* particle to add to command if a specific printer is edited */

    dia_queopts.remove_all();

    strcpy(my_header_text, MSG_U(M_QMGRQSTATUSREP, "Queue status report:\n"));
    my_queue_report=&my_header_text[0];
    my_queue_report+=strlen(my_queue_report);

    if(!strcmp(which_one, str_for_all)){
        strcpy(my_added_particle, " all");
        sprintf(my_titletx, MSG_U(M_QMGRMNGALLPRTQUEUE, "Managing all printers' queue"));
    } else {
        sprintf(my_added_particle, " %s", which_one);
        sprintf(my_titletx, MSG_U(M_QMGRMNTHATQUEUE, "Managing queue %s"), which_one);
    }
    sprintf(my_command_line, "lpc status%s", my_added_particle);
    execute_proggy_and_get_stdout(my_command_line, my_queue_report, 1023-strlen(&my_header_text[0]));

    dia_queopts.new_menuitem("", MSG_U(M_QMGRENEVTHING, "Enable everything (services fully operational)"));
    dia_queopts.new_menuitem("", MSG_U(M_QMGRENQUEUE, "Enable queueing"));
    dia_queopts.new_menuitem("", MSG_U(M_QMGRENPRINT, "Enable printing"));
    dia_queopts.newf_title(" ", "");
    dia_queopts.new_menuitem("", MSG_U(M_QMGRDISEVTHING, "Disable everything (services fully stopped)"));
    dia_queopts.new_menuitem("", MSG_U(M_QMGRDISQUEUE, "Disable queueing (jobs previously issued will be printed)"));
    dia_queopts.new_menuitem("", MSG_U(M_QMGRDISPRINT, "Disable printing (waits for the current job to finish)"));
    dia_queopts.newf_title(" ", "");
    dia_queopts.new_menuitem("", MSG_U(M_QMGRSTOPIMMED, "Stop immediately (aborts even the current job)"));
    dia_queopts.new_menuitem("", MSG_U(M_QMGRSTOPIMREMOVJOBS, "Stop immediately and remove all jobs from the queue"));
    dia_queopts.newf_title(" ", "");
    dia_queopts.new_menuitem("", MSG_U(M_QMGRLISTJOBSBT, "List jobs"));
    dia_queopts.new_menuitem("", MSG_U(M_QMGRRESTARTDAEMON, "Restart printer daemon"));

    /* adds extra [newline] to queue report string (last line could be ommited without this) */
    my_queue_report=&my_header_text[0];

    my_button=dia_queopts.editmenu(my_titletx, my_header_text, my_queuemsgmenu_helpfile, my_selection, MENUBUT_QUIT);
    if((my_button==MENU_QUIT)||(my_button==MENU_ESCAPE)){
        return;
    }

    switch(my_selection){
    case 0:
        strcpy(my_command_line, "lpc enable");
        strcat(my_command_line, my_added_particle);
        just_executes_the_proggy(my_command_line);
        strcpy(my_command_line, "lpc start");
        strcat(my_command_line, my_added_particle);
        just_executes_the_proggy(my_command_line);
        break;
    case 1:
        strcpy(my_command_line, "lpc enable");
        strcat(my_command_line, my_added_particle);
        just_executes_the_proggy(my_command_line);
        break;
    case 2:
        strcpy(my_command_line, "lpc start");
        strcat(my_command_line, my_added_particle);
        just_executes_the_proggy(my_command_line);
        break;
    case 4:
        strcpy(my_command_line, "lpc disable");
        strcat(my_command_line, my_added_particle);
        just_executes_the_proggy(my_command_line);
        strcpy(my_command_line, "lpc stop");
        strcat(my_command_line, my_added_particle);
        just_executes_the_proggy(my_command_line);
        break;
    case 5:
        strcpy(my_command_line, "lpc disable");
        strcat(my_command_line, my_added_particle);
        just_executes_the_proggy(my_command_line);
        break;
    case 6:
        strcpy(my_command_line, "lpc stop");
        strcat(my_command_line, my_added_particle);
        just_executes_the_proggy(my_command_line);
        break;
    case 8:
        strcpy(my_command_line, "lpc abort");
        strcat(my_command_line, my_added_particle);
        just_executes_the_proggy(my_command_line);
        break;
    case 9:
        if(confirm_yesno_window(MSG_U(M_QMGRSTOPCLEARTT, "Stopping printer and clearing queue"), MSG_U(M_QMGRSTOPCLEARTX, "You are going to stop the printer completely and\nerase its entire queue.\n\nSure you want to proceed?"))){
            strcpy(my_command_line, "lpc abort");
            strcat(my_command_line, my_added_particle);
            just_executes_the_proggy(my_command_line);
            sprintf(my_command_line, "lprm -P%s -", which_one);
            just_executes_the_proggy(my_command_line);
        }
        break;
    case 11:
        list_current_queue_state(which_one);
        break;
    case 12:
        strcpy(my_command_line, "lpc restart");
        strcat(my_command_line, my_added_particle);
        just_executes_the_proggy(my_command_line);
        break;
    }
    }
}

void queue_main_window(void)
{
    while(1){

    char *my_buff=NULL;
    FILE_CFG *my_file;
    int  myfilesize;
    int  its_ok=0;
    int  my_selection;
    MENU_STATUS  my_button;
    char my_queuelist[1000];
    char *my_pick_list;

    if((my_file=cf_printcapfile.fopen("r"))){
        fseek(my_file, 0, SEEK_END);
        myfilesize=ftell(my_file);
        fseek(my_file, 0, SEEK_SET);
        if((my_buff=(char *)malloc(myfilesize+1))){
            *my_buff=0;
            *(my_buff+myfilesize)=0;
            fread(my_buff, myfilesize, 1, my_file);
            /* ok, whole file readen */
            its_ok=1;
        }
        cf_printcapfile.fclose(my_file);
    }

    if(its_ok){
        int i;
        char       str_every_one[TYPICAL_STRING_SIZE];
        int total_items_added;
        DIALOG_RECORDS     dia_queequeg;

        {
//            DIALOG_RECORDS     dia_queequeg;
            char       retnd_hostname[500];
            char       *queuename_delimiter;
            char       *for_list_creation;

            dia_queequeg.remove_all();
            total_items_added=0;

            for_list_creation=&my_queuelist[0];
            *for_list_creation=0;
            strcpy(str_every_one, MSG_U(M_QMGRALLQUEUES, "all queues"));

            dia_queequeg.newf_head("", MSG_U(M_QMGRQUEUESPRESENT, "queues present"));

            /* uncomment this in order to enable the 'all queues' item (partially supported, that's why it was dropped) */
//            dia_queequeg.new_menuitem(str_every_one, "");
//            strcat(for_list_creation, str_every_one);
//            for_list_creation+=strlen(for_list_creation)+1;


            i=0;
            while(copy_specific_block(my_buff, "", i++, retnd_hostname)){
                if((queuename_delimiter=strchr(retnd_hostname, ':')))
                    *queuename_delimiter=0;
                if((queuename_delimiter=strchr(retnd_hostname, '|')))
                    *queuename_delimiter=0;
                dia_queequeg.new_menuitem(retnd_hostname, "");
                total_items_added++;
                strcpy(for_list_creation, retnd_hostname);
                for_list_creation+=strlen(for_list_creation)+1;
            }
            *for_list_creation=0; /* puts double-zero as end of table */

            my_selection=0;
            my_button=dia_queequeg.editmenu(MSG_U(M_QMGRQUEUEMGRTT, "Queue manager"), MSG_U(M_QMGRQUEUEMGRTX, "Select the queue you want to manage."), my_queuemgrmain_helpfile, my_selection, MENUBUT_QUIT);
        }

        switch(my_button){
        case MENU_QUIT:
        case MENU_ESCAPE:
            if(my_buff)
                free(my_buff);
            return;
        default:
            if(total_items_added){
                /* edit specified queue */
                i=my_selection;
                my_pick_list=&my_queuelist[0];
                while(i--){
                    my_pick_list+=strlen(my_pick_list)+1;
                }
                edit_specified_queue(my_pick_list, str_every_one);
            }
            break;
        }


    }

    if(my_buff)
        free(my_buff);
    }
}
